#! /bin/bash

# 2020 by C. Masloch

# Usage of the works is permitted provided that this
# instrument is retained with the works, so that any entity
# that uses the works is notified of this instrument.
#
# DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

if [ \! -d lmacros ]
then
  hg clone https://hg.ulukai.org/ecm/lmacros
else
  (cd lmacros && hg pull && hg up)
fi
if [ \! -d ldosboot ]
then
  hg clone https://hg.ulukai.org/ecm/ldosboot
else
  (cd ldosboot && hg pull && hg up)
fi
if [ \! -d instsect ]
then
  hg clone https://hg.ulukai.org/ecm/instsect
else
  (cd instsect && hg pull && hg up)
fi
if [ \! -d fdos ]
then
  git clone https://github.com/FDOS/kernel.git fdos
else
  (cd fdos && git pull --ff-only)
fi

nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=0 -D_CHS=1 -D_LBA=0 -o b12fdNNC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=1 -D_USE_PART_INFO=0 -D_CHS=1 -D_LBA=0 -o b12fdQNC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=1 -D_CHS=1 -D_LBA=0 -o b12fdNUC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=1 -D_USE_PART_INFO=1 -D_CHS=1 -D_LBA=0 -o b12fdQUC.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=0 -D_CHS=0 -D_LBA=1 -o b12fdNNL.bin
nasm -f bin -D_FAT12=1 ldosboot/boot.asm -I lmacros/ -D_COMPAT_FREEDOS -D_RPL=0 -D_QUERY_GEOMETRY=0 -D_USE_PART_INFO=1 -D_CHS=0 -D_LBA=1 -o b12fdNUL.bin
nasm -f bin -DISFAT12 fdos/boot/boot.asm -o b12fdorg.bin

for letters in NNC QNC NUC QUC NNL NUL org
do
  nasm -D_PAYLOAD_FAT12="'b12fd$letters.bin'" -D_FAT12=1 -D_FAT16=0 -D_FAT32=0 instsect/instsect.asm -I ./ -I lmacros/ -o ifd12$letters.com
done
